# Copyright (C) 2004, 2005  National Institute of Advanced Industrial Science and Technology
#
# This file is part of msgcab.
#
# msgcab is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# msgcab is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with msgcab; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

class FilterRule
  def apply(number)
    fields = MsgCab::CLI.database.header_fields(number)
    folder_name, = fields['x-ml-name']
    unless folder_name
      body, = fields['list-id']
      if body && body =~ /<(.*)>/
        folder_name = $1
      end
    end
    return "unknown:#{number}" unless folder_name
    folder_name = folder_name.downcase
    folder_name.gsub!(/[^-a-z\d]/, '-')
    folder_name.gsub!(/-+/, '-')

    folder_number, = fields['x-ml-count']
    unless folder_number
      folder_number, = fields['x-mail-count']
    end
    return "unknown:#{number}" unless folder_number
    "#{folder_name}:#{folder_number}"
  end
end
